<?php
/*
Plugin Name: Polaroid on the Fly
Plugin URI: http://sivel.net/wordpress/
Description: Creates polaroids of images on the fly for thumbnails in posts. Support for lightbox included. Built on modified Polaroidonizer v0.7.2 sources.
Version: 0.3
Author: Matt Martz
Author URI: http://sivel.net

        Copyright (c) 2007 Matt Martz (http://sivel.net)
        Polaroid on the Fly is released under the GNU General Public License (GPL)
        http://www.gnu.org/licenses/gpl.txt

        This is a WordPress 2 plugin (http://wordpress.org).
	Polaroidonizer is licensed under the GNU General Public License (GPL)
	http://www.gnu.org/licenses/gpl.txt
*/

// Initialize Globabl variables
$plugin_name = dirname(plugin_basename(__FILE__));
$siteurl = get_settings('siteurl');
$plugin_uri = 'wp-content/plugins/' . $plugin_name . '/';
$plugin_url = $siteurl . '/' . $plugin_uri;

// Begin function to replace text
function polaroid_replace($page_content) {

	// Import Global Variables
	GLOBAL $plugin_name, $siteurl, $plugin_uri, $plugin_url;

	// Define Search Paramenters
	$search = '/(<p\>)?<img(.*)?src\=[\'|"](.*)\.(jpg|jpeg|gif|png)[\'|"](.*)?rel\=[\'|"]polaroid[\'|"](.*)((alt\=[\'|"](.*)[\'|"]))?(.*)?(\/)?\>(<\/p\>)?/i';

	// Check the page content for matches
	if (preg_match_all($search, $page_content, $matches, PREG_SET_ORDER)) {

		// Loop through each match
        	foreach ($matches as $match) :

			// Grab and format originally passed image url
                	preg_match('/src\=[\'|"](.*)\.(jpg|jpeg|gif|png)[\'|"]/',$match[0],$url_results);
	                $url_orig = preg_replace('/(src\=)?[\'|"]/', '', $url_results[0]);

			// Grab and format orignally passed alt text
        	        preg_match('/alt\=[\'|"](.*)[\'|"]/',$match[0],$alt_results);
	                $alt_orig = preg_replace('/(alt\=)?[\'|"]/', '', $alt_results[0]);
        	        $alt_nolight = preg_replace('/\[(.*)\]/', '', $alt_orig);

			// Grab album name
			preg_match('/\[(.*)\]/', $alt_orig, $album_results);
			$album = $album_results[0];		
	
			// Run tinyutl.com api and grab the shortened url
	                $url_handle = fopen("http://tinyurl.com/api-create.php?url=" . $url_orig, "r");
        	        $url_tiny = fread($url_handle, 1024*1024);
                	fclose($url_handle);

			// Create encoded part of URL for final polaroid image link
	                $encoded = base64_encode("255,255,255||" . $url_tiny . "||0||0||0||");
	
			// Define Repalce Paramenters
        	        $replace = '<a href="' . $url_tiny . '" rel="lightbox' . $album . '" title="' . $alt_nolight . '"><img src="' . $plugin_url . $encoded . '/polaroid.jpg" alt="' . $alt_nolight . '" height=150 width=123 border=0 /></a>';

			// Make replacements
			$page_content = str_replace($match[0], $replace, $page_content);

	        endforeach;
	}
	
	// Return the modified page content
	return $page_content;
}

// Add filter to Wordpress to make substitutions from above function
add_filter('the_content', 'polaroid_replace');
?>
